﻿Type=Service
Version=1.60
StartAtBoot=False
@EndOfDesignText@
'Service module
Sub Process_Globals
	Dim rv As RemoteViews
	Dim parser As SaxParser
	Dim quotes As List
	Type QuoteItem(Text As String, Link As String)
	Dim currentQuote As Int
	Dim quoteItemForParsing As QuoteItem
	Dim firstItem As Boolean
	Dim raf As RandomAccessFile
	Dim QUOTES_FILE, CURRENTQUOTE_FILE As String
	QUOTES_FILE = "quotes.dat"
	CURRENTQUOTE_FILE = "currentQuote.txt"
End Sub
Sub Service_Create
	'configure the widget and set it to update every 24 hours (1440 minutes).
	rv = ConfigureHomeWidget("WidgetLayout", "rv", 1440, "Quote of the day")
	HttpUtils.CallbackActivity = "WidgetService"
	HttpUtils.CallbackUrlDoneSub = "UrlDone"
	HttpUtils.CallbackJobDoneSub = "JobDone"
	parser.Initialize
	
	'Load previous data if such is available.
	'This is relevant in case our process was killed and now the user pressed on the widget.
	If File.Exists(File.DirInternalCache, QUOTES_FILE) Then
		raf.Initialize(File.DirInternalCache, QUOTES_FILE, True)
		quotes = raf.ReadObject(0)
		raf.Close
	Else
		quotes.Initialize
	End If
	If File.Exists(File.DirInternalCache, CURRENTQUOTE_FILE) Then
		currentQuote = File.ReadString(File.DirInternalCache, CURRENTQUOTE_FILE)
	End If
End Sub

Sub Service_Start (StartingIntent As Intent)
	If rv.HandleWidgetEvents(StartingIntent) Then Return
End Sub
Sub rv_RequestUpdate
	quotes.Clear
	currentQuote = -1
	HttpUtils.DownloadList("Quotes", Array As String("http://feeds.feedburner.com/brainyquote/QUOTEBR", _
		"http://feeds.feedburner.com/brainyquote/QUOTEAR", "http://feeds.feedburner.com/brainyquote/QUOTEFU", _
		"http://feeds.feedburner.com/brainyquote/QUOTELO", "http://feeds.feedburner.com/brainyquote/QUOTENA"))
End Sub
Sub rv_Disabled
	StopService("")
End Sub

Sub imgNext_Click
	If quotes.Size = 0 Then 
		rv_RequestUpdate
	Else
		ChooseQuoteFromList
		rv.UpdateWidget
	End If
End Sub
Sub lblQuote_Click
	If quotes.Size > 0 Then
		Dim qi As QuoteItem
		qi = quotes.Get(currentQuote)
		Dim i As Intent
		i.Initialize(i.ACTION_VIEW, qi.Link)
		StartActivity(i)
	End If
End Sub
Sub UrlDone (url As String)
	firstItem = True
	parser.Parse(HttpUtils.GetInputStream(url), "parser")
End Sub
Sub JobDone(Job As String)
	Log("Number of quotes: " & quotes.Size)
	If quotes.Size = 0 Then
		rv.SetText("lblQuote", "No quotes are available :(")
	Else
		ChooseQuoteFromList
	End If
	rv.UpdateWidget
	raf.Initialize(File.DirInternalCache, QUOTES_FILE, False)
	raf.WriteObject(quotes, True, 0)
	raf.Close
End Sub
Sub ChooseQuoteFromList
	currentQuote = (currentQuote + 1) Mod quotes.Size
	Dim qi As QuoteItem
	qi = quotes.Get(currentQuote)
	rv.SetText("lblQuote", qi.Text)
	File.WriteString(File.DirInternalCache, CURRENTQUOTE_FILE, currentQuote)
End Sub
Sub parser_StartElement (Uri As String, Name As String, Attributes As Attributes)
	If Name = "item" Then
		Dim quoteItemForParsing As QuoteItem 'create a new item
		quoteItemForParsing.Initialize
	End If
End Sub
Sub parser_EndElement (Uri As String, Name As String, Text As StringBuilder)
	If parser.Parents.IndexOf("item") >= 0 Then
		Select Name
			Case "title"
				quoteItemForParsing.Text = Text.ToString
			Case "description"
				quoteItemForParsing.Text = quoteItemForParsing.Text & ": " & _ 
					Text.ToString
			Case "link"
				quoteItemForParsing.Link = Text.ToString
		End Select
	Else If Name = "item" Then
		If firstItem Then 'insert the first item at the beginning of the list
			quotes.InsertAt(0, quoteItemForParsing)
			firstItem = False
		Else
			quotes.Add(quoteItemForParsing)
		End If
	End If
End Sub
Sub Service_Destroy

End Sub
